leetcode_3273 数位平方和的最大值

1. 题意

给你两个 正 整数 num 和 sum。

如果一个正整数 n 满足以下两个条件,则称其为 好整数 :

n 的位数 恰好 为 num。

n 的各位数字之和 恰好 为 sum。

一个 好整数 n 的 分数 定义为 n 的各位数字的平方和。

返回一个 字符串 ,表示能获得 最大分数 的 好整数 n。如果有多个可能的整数,返回 最大 的那个。如果不存在这样的整数,返回一个空字符串。

2. 题解

贪心策略,尽可能使用各个数之间的距离远。

在这个题目中就是让9的位数足够多,那么其实就是 ⌊ s u m / 9 ⌋ \lfloor sum/9 \rfloor ⌊sum/9⌋位;

如果sum % 9 != 0 ,那么还需要补一位'0' + sum % 9

剩下的位数用0搞定

2.1 代码
  • sol1
cpp 复制代码
class Solution {
public:
    string maxSumOfSquares(int num, int sum) {
        
        // 1 > 9 ?
        // 2 > 18 ?

        if ( sum > num * 9)
            return string("");


        string ans{};
        int s = sum;
        for (int i = 0;i < num; ++i) {
            if (s >= 9) {
                ans.push_back('9');
                s -= 9;
            }
            else if ( s > 0) {
                ans.push_back('0' + s);
                s = 0;
            }
            else {
                ans.push_back('0');
            }
        }

        return ans;
    }
};
  • sol2
cpp 复制代码
class Solution {
public:
    string maxSumOfSquares(int num, int sum) {
        
        // 1 > 9 ?
        // 2 > 18 ?

        if ( sum > num * 9)
            return string("");


        int cnt_9 = sum / 9;
        int lf = sum % 9;
        int cnt_0 = num - cnt_9;
        if (0 != lf)
            cnt_0--;
        string ans(cnt_9, '9');
        if (0 != lf)
            ans.push_back('0' + lf);
        ans.append( cnt_0, '0');

        return ans;
    }
};
2.2 正确性证明

这个题目实际上求得是一个最大的序列

s e q = ( a 0 , a 1 , ⋯   , a n ) , a i ∈ { 0 , 1 , ⋯ 9 } seq = (a_0,a_1,\cdots,a_n) ,a_i \in \{ 0,1,\cdots 9\} seq=(a0,a1,⋯,an),ai∈{0,1,⋯9}

且约束为

∑ i = 0 n a i = S \sum_{i=0}^na_i=S i=0∑nai=S

要求平方和的最大值

Q = ∑ i = 0 n a i 2 Q = \sum_{i=0}^{n}a_i^2 Q=i=0∑nai2

我们简单分析下 n = 2 n=2 n=2的情况

Q = x 2 + ( S − x ) 2 = 2 ( x 2 − S x ) + S 2 Q=x^2+(S-x)^2 =2(x^2-Sx) +S^2 Q=x2+(S−x)2=2(x2−Sx)+S2

Q是一个关于x的二次函数,对称轴为 x = S 2 x=\frac{S}{2} x=2S

当 x x x离 S 2 \frac{S}{2} 2S越远,则 Q Q Q越大。

且还需要满足

0 ≤ x ≤ 9 , 0 ≤ S − x ≤ 9 0 \le x \le 9,0 \le S-x \le 9 0≤x≤9,0≤S−x≤9

S ≤ 9 S \le 9 S≤9时,最优为 0 , S 0,S 0,S

S > 9 S > 9 S>9时,最优为 9 , S − 9 9,S-9 9,S−9

如何推广到 n n n维呢?

我们只需要证明:最优序列中不可能存在两个数位都严格在 ( 0 , 9 ) (0,9) (0,9) 内部。

否则只调整这两个数位,就能让平方和变大,矛盾。

我们假设最优的解序列中有一对数 0 < a i ≤ a j < 9 0 < a_i \le a_j <9 0<ai≤aj<9 不满足上面的情况。

那我们可以作以下调整

a i ′ = a i − 1 a j ′ = a j + 1 Δ = a i ′ 2 + a j ′ 2 − a i 2 − a j 2 = 2 ( a j − a i ) + 2 a_i'=a_i-1 \quad a_j'=a_j+1\\ \Delta={a_i'}^2 +{a_j'}^2 -a_i^2-a_j^2=2(a_j-a_i) + 2 ai′=ai−1aj′=aj+1Δ=ai′2+aj′2−ai2−aj2=2(aj−ai)+2

显然 a j ≥ a i a_j\ge a_i aj≥ai,因此调整后的值会变大!这与假设的最优序列矛盾。

因此最优序列中一定不存在一对数满足 0 < a i ≤ a j < 9 0 < a_i \le a_j < 9 0<ai≤aj<9

这等价于最优序列中只存在至多一位数在 ( 0 , 9 ) (0,9) (0,9)中间

那么我们的最优序列一定是形如

9 , ⋯   , 9 , r , 0 , ⋯ 0 9,\cdots ,9,r,0,\cdots 0 9,⋯,9,r,0,⋯0

参考

0x3f

相关推荐
vivo互联网技术1 小时前
SSR-Merge:把 LoRA 合并从"参数算术"变成"信号路由" | ICML 2026
人工智能·算法·计算机视觉
罗湖老棍子1 小时前
座位安排(洛谷-P2071)
c++·算法·图论·匈牙利算法·二分图匹配
巴糖1 小时前
挑礼物这件事,暴露了你做选择时最大的问题
算法
用户7341681035481 小时前
控制与监测特征的联合表征:复杂动力装备变工况故障诊断的发展方向
算法
垆边人似月.1 小时前
华为题:无重复字符的最长子串变种
算法
糖果豆豆1 小时前
灾难性遗忘不是"新旧打架"——旧知识记不住,是因为它没长成"环"
算法
垆边人似月.1 小时前
华为题:任务调度
数据结构·c++·算法
垆边人似月.1 小时前
华为题:编辑距离
算法·华为
会灭火的程序员1 小时前
大模型部署硬件资源计算指南:从显存估算到显卡选型
人工智能·算法